AndroidX了解一下

推荐阅读:Android 开发高手课 温故知新篇

1.说明

官方原文如下

We hope the division between android.* and androidx.* makes it more obvious which APIs are bundled with the platform, and which are static libraries for app developers that work across different versions of Android.

简单地说就是新的库可以在不同的Android版本上使用。比如之前我们如果使用support为27.1.1的相关依赖库时。可能需要所有相关的support 库都为27.1.1。如果其中有bug的话,可能需要所有的都去升级,存在一个绑定关系,而且正式版的发布周期也很长。

通过AndroidX,我们可以看到实时实现的特性和bug修复。升级个别依赖,不需要对使用的所有其他库进行更新。这就和我们使用Github上的开源库一样的,出了问题,我们可以提出bug和意见。作者修复后,发布新版本,我们就可以直接替换使用了。更加的透明便捷。

2.变化

我选取了几个常用依赖库,我们可以看看变化:

Old build artifactAndroidX build artifact
com.android.support:support-compatandroidx.core:core:1.0.0+
com.android.support:appcompat-v7androidx.appcompat:appcompat:1.0.0+
com.android.support:designcom.google.android.material:material:1.0.0+
com.android.support:multidexandroidx.multidex:multidex:2.0.0+
com.android.support:recyclerview-v7androidx.legacy:legacy-support-v4:1.0.0+
com.android.support:viewpagerandroidx.viewpager:viewpager:1.0.0+
com.android.support:support-fragmentandroidx.fragment:fragment:1.0.0+

当然涉及的不止这些库,更详细的变化内容可以查看官方文档

我们可以添加appcompat依赖对比一下:

implementation 'com.android.support:appcompat-v7:28.0.0-beta1'
或
implementation 'androidx.appcompat:appcompat:1.0.0-beta01'

可以看到详细变化

  

同时我们看到viewpagerswiperefreshlayoutcoordinatorlayout 等一些UI组件被分离了出来,这样也是便于更好的使用,职责分明,以减轻不使用ProGuardMultidex的应用程序和测试的压力。

3.影响

官方博客中有说道,为了给开发者一定迁移的时间,所以28.0.0的稳定版本还是采用android.support。但是所有后续的功能版本都将采用androidx

其实对于我们影响也不是很大,我们可以选择不使用,毕竟不是强制的。但长远看来还是有好处的。接受变化,拥抱变化也是我们程序猿需要有的精神,欢迎尝试。

对于有写一些开源项目的人,可能会有一些影响。比如你有一个关于RecyclerView的拓展库,那么你就需要去让他支持AndroidX,否则你懂的。

我有去看了一下我们常用的butterknifeglide 等都已经适配了AndroidX,不得不说真是很良心。

在这里插入图片描述

在这里插入图片描述

4.迁移

如果一个一个去替换当然很麻烦了,所以在Android Studio 3.2 Canary中添加了一键迁移的功能Refactor -> Migrate to AndroidX

首先你的gradle版本至少为3.2.0以上,以及compileSdkVersion为28以上。

classpath 'com.android.tools.build:gradle:3.2.0+'

如果你是一个新项目,如果使用AndroidX相关依赖,需要在gradle.properties文件里添加配置:

android.useAndroidX=true
android.enableJetifier=true

如果你想使用AndroidX,但是之前的不迁移,可以这样配置:

android.useAndroidX=true
android.enableJetifier=false

5.参考

当然迁移最好是出了正式版后在尝试。这里目的也就和标题一样,了解一下(坚决不做标题党哈)。


19.02.12补充

今天看到了butterknife的一个Issues

在这里插入图片描述

大意就是butterknife最新的10.0.0已经不支持老版库,如果需要使用,只能使用9.0.0这版。这也就是一种趋势,希望开源作者和使用者互相约束,共同推广AndroidX

19.09.24补充

Android Studio 3.5开始(可能更早吧),新建项目默认“强制”使用AndroidX。项目中的support依赖自动替换为AndroidX对应的依赖包。

这主要是gradle.properties文件中的 android.enableJetifier=true在起作用。如果你想迁移到AndroidX,也可以添加这行配置,这样就不用担心之前开源项目未适配的情况。

  • 26
    点赞
  • 97
    收藏
    觉得还不错? 一键收藏
  • 20
    评论
引用和提到了androidx中实现Fragment懒加载的方案。在androidx中,可以使用setMaxLifecycle()方法来设置Fragment的状态,取代了setUserVisibleHint()方法。通过在构造FragmentPagerAdapter时传入BEHAVIOR_RESUME_ONLY_CURRENT_FRAGMENT参数,并将加载数据的逻辑放到Fragment的onResume()方法中,就可以实现Fragment的懒加载。这种方案可以有效地减少不必要的数据加载和提高性能。同时,androidx还引入了一些新的内容,为开发者提供了很多便利。你可以参考相关的文章和代码来深入了解和实践该方案。 引用提到了网上已经有很多关于androidx的Fragment懒加载的文章,但大多数只是点到了setMaxLifecycle()和修改FragmentPagerAdapter这两个方面,很少有实践的文章。因此,该文章详细记录了作者实践后的结果,可以作为更加详尽的参考。 总结起来,androidx中的Fragment懒加载可以通过setMaxLifecycle()方法和修改FragmentPagerAdapter来实现,并且androidx还引入了一些新的内容,为开发者提供了更多便利。你可以参考相关的文章和代码来了解和实践该方案。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* [androidx中的Fragment懒加载方案](https://blog.csdn.net/qq_36486247/article/details/102531304)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 33.333333333333336%"] - *2* [androidx中的Fragment懒加载](https://blog.csdn.net/tongsiw/article/details/107991830)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 33.333333333333336%"] - *3* [androidx下的fragment的lazy懒加载问题详解](https://download.csdn.net/download/weixin_38606656/14916018)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 33.333333333333336%"] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 20
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值